import * as GameTest from 'mojang-gametest';
import {Commands,World,ItemStack,MinecraftItemTypes,MinecraftBlockTypes, BlockPermutation, BlockProperties, BlockInventoryComponentContainer, BlockInventoryComponent, BlockLocation} from 'mojang-minecraft';
    
const effectCallback = World.events.effectAdd;
//const chatCallback = World.events.beforeChat;
const createEntity = World.events.entityCreate;

effectCallback.subscribe(effectFunction);
createEntity.subscribe(cEntity);
//chatCallback.subscribe(bChat);	  

var inv_temp = [];
var main_inv = null;
/*
function bChat(chatData) 
{
let itemObj = [];
if(chatData.message == "!invSort"){
Commands.run(`say Inventory Sorting!`, World.getDimension("overworld"));
try{
let player = chatData.sender;
let pInv = player.getComponent("inventory").container;
	for(let slot=9; slot<pInv.size; slot++){
		let item = pInv.getItem(slot);
		if(item != null){
		itemObj.push(item);
		pInv.setItem(slot,new ItemStack(MinecraftItemTypes.barrier,1,0));
		}
	}
	inv_temp = itemObj;
	main_inv = pInv;
	Commands.run(`execute @a[name="${player.nameTag}"] ~ ~ ~ clear @s barrier`, World.getDimension("overworld"));
	Commands.run(`execute @a[name="${player.nameTag}"] ~ ~ ~ summon sorter:inv_temp`, World.getDimension("overworld"));
}catch(e){
Commands.run(`say ${e}`, World.getDimension("overworld"));			
}
}
}	
*/
function cEntity(entityData){
if(entityData.entity.id == "sorter:inv_temp"){
try{
let entity = entityData.entity;
let entityInv = entity.getComponent("inventory").container;
let itemObj = [];
let itemOrder = [];
let slotIndex = 9;
let arraySlot = 0;
	//set player item to temp inv
	for(let slot=0; slot<inv_temp.length; slot++){
		entityInv.addItem(inv_temp[slot]);
	}
	//read inventory of temp inv
	for(let slot=0; slot<entityInv.size; slot++){
		let item = entityInv.getItem(slot);
		if(item != null){
		itemObj.push(item);
		itemOrder.push(item.id + item.data + "-" + arraySlot);
		arraySlot++;
		}
	}
	itemOrder.sort();
	//transfer items from temp inv to player
	for(let slot=0; slot<itemObj.length; slot++){
		let itemStr = itemOrder[slot].split("-");
		let itemIndex = itemStr[1];		
		main_inv.setItem(slotIndex,itemObj[parseInt(itemIndex)]);
		slotIndex++;
	}
	inv_temp = [];
	main_inv = null;
	runCommand(`event entity @e[type=sorter:inv_temp] despawn`);
}catch(e){
//Commands.run(`say ${e}`, World.getDimension("overworld"));				
}
}
}
 
function effectFunction(effectData){	
	let effectName = effectData.effect.displayName;
	let effectAmp = effectData.effect.amplifier;
	let entity = effectData.entity;				
	if((effectName == 'Nausea' && effectAmp == 10) && entity.id == 'minecraft:player'){
	inventorySort(effectData);			
	}	
}

function inventorySort(entityPlayer){
let itemObj = [];
try{
let player = entityPlayer.entity;
let pInv = player.getComponent("inventory").container;
	for(let slot=9; slot<pInv.size; slot++){
		let item = pInv.getItem(slot);
		if(item != null){
		itemObj.push(item);
		pInv.setItem(slot,new ItemStack(MinecraftItemTypes.barrier,1,0));
		}
	}
	inv_temp = itemObj;
	main_inv = pInv;
	runCommand(`title @a[name="${player.nameTag}"] actionbar §6Inventory Sorted!`);
	runCommand(`execute @a[name="${player.nameTag}"] ~ ~ ~ clear @s barrier`);
	runCommand(`execute @a[name="${player.nameTag}"] ~ ~ ~ summon sorter:inv_temp`);
}catch(e){
runCommand(`say ${e}`);			
}
}

function hotBarItems(pInv){
//Get Hotbar Items
let hotbarObj = [];
	for(let slot=0; slot<9; slot++){
		let item = pInv.getItem(slot);	
		if(item != null){						
			hotbarObj.push(item);	
		}else{
			hotbarObj.push(null);	
		}
	}	
	return hotbarObj;
}

function runCommand(command){
try{
Commands.run(command, World.getDimension("overworld"));
Commands.run(command, World.getDimension("nether"));
Commands.run(command, World.getDimension("the end"));
}catch(e){
//Commands.run(`say ${e}`, World.getDimension("overworld"));	
}
}
